/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler;

import com.geekcap.modeler.dao.PropertiesFileUmlTypeDaoImpl;
import com.geekcap.modeler.dao.Xmi14DomainObjectDaoImpl;
import com.geekcap.modeler.service.ModelerService;
import com.geekcap.modeler.service.ModelerServiceImpl;
import com.geekcap.modeler.service.TemplateService;
import com.geekcap.modeler.service.VelocityTemplateServiceImpl;
import java.io.FileInputStream;

/**
 *
 * @author shaines
 */
public class Modeler
{
    private ModelerService modelerService;

    public Modeler()
    {
        // Wire together a ModelerService
        TemplateService templateService = new VelocityTemplateServiceImpl();
        Xmi14DomainObjectDaoImpl dao = new Xmi14DomainObjectDaoImpl();
        dao.setUmlTypeDao( new PropertiesFileUmlTypeDaoImpl() );
        modelerService = new ModelerServiceImpl( templateService, dao );
    }

    public void generate( String modelFile, String path, String artifact )
    {
        try
        {
            modelerService.generate( new FileInputStream( modelFile ), path, artifact );
        }
        catch( Exception e )
        {
            e.printStackTrace();;
        }
    }

    public static void main( String[] args )
    {
        if( args.length < 3 )
        {
            System.out.println( "Usage: Modeler <model-file> <destination-path> <artifact>" );
            System.exit( 0 );
        }

        // Load our parameters
        String modelFile = args[ 0 ];
        String path = args[ 1 ];
        String artifact = args[ 2 ];

        // Create our modeler
        Modeler modeler = new Modeler();

        // Generate our artifacts
        modeler.generate( modelFile, path, artifact );
    }
}
