/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.dao;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;

/**
 * Loads templates from the classpath
 *
 * @author shaines
 */
public class ClasspathTemplateDaoImpl implements TemplateDao
{
    /**
     * Loads the specified template and returns its contents as a String
     *
     * @param templateName      The name of the template to load
     *
     * @return                  The contents of the template
     */
    public String loadTemplate( String templateName )
    {
        try
        {
            // Load the template
            String templateFile = "templates/" + templateName + ".vtl";
            InputStream in = getClass().getClassLoader().getResourceAsStream( templateFile );
            BufferedReader br = new BufferedReader( new InputStreamReader( in ) );

            // Read the template into our StringBuilder
            StringBuilder sb = new StringBuilder();
            String line = br.readLine();
            while( line != null )
            {
                sb.append( line ).append( "\n" );
                line = br.readLine();
            }

            // Close the stream
            br.close();

            // Return our template
            return sb.toString();
        }
        catch( IOException e )
        {
            e.printStackTrace();
        }
        return null;
    }
}
