/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.dao;

import com.geekcap.modeler.model.DomainModel;
import java.io.InputStream;

/**
 * Defines methods that classes that load DomainObjects, such as from various version of XMI
 * documents, need to implement
 *
 * @author shaines
 */
public interface DomainObjectDao
{
    /**
     * Loads the domain objects contained in the specified input stream
     * 
     * @param in            An input stream to the artifact that contains the domain objects
     * 
     * @return              A domain model loaded from the input stream
     */
    public DomainModel loadDomainModel( InputStream in );
}
