/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.dao;

import java.util.HashMap;
import java.util.Map;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.jdom.Document;
import org.jdom.input.SAXBuilder;

/**
 * Loads UML type information from a remote host using HttpClient
 *
 * @author shaines
 */
public class HttpClientUmlTypeDaoImpl implements UmlTypeDao
{
    /**
     * Jakarta Commons HttpClient; used for communicating with the Google server
     */
    private HttpClient httpClient = new DefaultHttpClient();

    /**
     * Maps URLs to their JDOM documents so that if we have types defined in the same
     * URL, we only load the document once
     */
    private Map<String, Document> documentMap = new HashMap<String, Document>();

    public HttpClientUmlTypeDaoImpl()
    {
    }

    /**
     * Given a URL of the following form, this method returns a String repreentation of
     * its type:
     *
     *      http://argouml.org/profiles/uml14/default-java.xmi#.:000000000000086E
     *
     * @param url           A URL to the remote type
     *
     * @return              The remote type or null if the type is not a URL
     */
    public String getRemoteType( String url )
    {
        // Separate the URL from the "#arg"
        String key = null;
        if( url.indexOf( '#' ) != -1 )
        {
            key = url.substring( url.indexOf( '#' ) + 1 );
            url = url.substring( 0, url.indexOf( '#' ) );
        }

        // Load the document
        Document doc = loadDocument( url );

        // Find our key
        // TODO: A lot of work here, for now fall back to the PropertiesFileUmlTypeDaoImpl class ...

        return null;
    }

    protected Document loadDocument( String url )
    {
        if( documentMap.containsKey( url ) )
        {
            // We've already loaded this document, so return it from our map
            return documentMap.get( url );
        }
        
        try
        {
            // This is a new document, load it
            HttpGet httpGet = new HttpGet( url );
            HttpResponse httpResponse = httpClient.execute( httpGet );
            HttpEntity entity = httpResponse.getEntity();
            if( entity != null )
            {
                // Parse the document
                SAXBuilder builder = new SAXBuilder();
                Document doc = builder.build( entity.getContent() );
                
                // Add it to our map
                documentMap.put( url, doc );
                
                // Return the document
                return doc;
            }
        }
        catch( Exception e )
        {
            e.printStackTrace();;
        }
        return null;
    }
}
