/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.dao;

import java.util.Enumeration;
import java.util.Properties;

/**
 *
 * @author shaines
 */
public class PropertiesFileUmlTypeDaoImpl implements UmlTypeDao
{
    protected Properties properties = new Properties();

    public PropertiesFileUmlTypeDaoImpl()
    {
        try
        {
            // Load the ArgoUML properties
            properties.loadFromXML( getClass().getClassLoader().getResourceAsStream( "argouml-types.xml" ) );
            Enumeration e = properties.propertyNames();
            System.out.println( "ArgoUML properties" );
            while( e.hasMoreElements() )
            {
                String key = ( String )e.nextElement();
                String value = properties.getProperty( key );
                System.out.println( "\t" + key + " = " + value );
            }
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
    }

    /**
     * Given a URL of the following form, this method returns a String repreentation of
     * its type:
     *
     *      http://argouml.org/profiles/uml14/default-java.xmi#.:000000000000086E
     *
     * @param url           A URL to the remote type
     *
     * @return              The remote type or null if the type is not a URL
     */
    public String getRemoteType( String url )
    {
        if( url == null )
        {
            return null;
        }
        else if( url.startsWith( "http://argouml.org/profiles/uml14/default-uml14.xmi" ) ||
            url.startsWith( "http://argouml.org/profiles/uml14/default-java.xmi" ) )
        {
            String key = url.substring( url.indexOf( '#' ) + 1 );
            if( key != null )
            {
                return properties.getProperty( key );
            }
        }
        return null;
    }
}
