/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.dao;

/**
 * Defines methods for obtaining the type for UML model attributes, which typically
 * are defined using a URL
 *
 * @author shaines
 */
public interface UmlTypeDao
{
    /**
     * Given a URL of the following form, this method returns a String repreentation of 
     * its type:
     * 
     *      http://argouml.org/profiles/uml14/default-java.xmi#.:000000000000086E
     * 
     * @param url           A URL to the remote type
     * 
     * @return              The remote type or null if the type is not a URL
     */
    public String getRemoteType( String url );
}
