package com.geekcap.modeler.model;

import java.util.ArrayList;
import java.util.List;

/**
 * Represents a class operation
 *
 * @author shaines
 */
public class Operation
{
    public enum Visibility
    {
        PUBLIC, PROTECTED, PRIVATE

    }
    /**
     * The name of the operation
     */
    private String name;

    /**
     * The visibility of the operation
     */
    private Visibility visibility;

    /**
     * The operation's return type
     */
    private String returnType;

    /**
     * The list of parameters passed to the operation
     */
    private List<OperationParameter> parameters = new ArrayList<OperationParameter>();

    public Operation()
    {
    }

    public Operation( String name )
    {
        this.name = name;
    }

    public List<OperationParameter> getParameters()
    {
        return parameters;
    }

    public String getName()
    {
        return name;
    }

    public void setName( String name )
    {
        this.name = name;
    }

    public String getReturnType()
    {
        return returnType;
    }

    public void setReturnType( String returnType )
    {
        this.returnType = returnType;
    }

    public Visibility getVisibility()
    {
        return visibility;
    }

    public void setVisibility( Visibility visibility )
    {
        this.visibility = visibility;
    }
}
