/*
 * (c) Copyright 2010 GeekCap, Inc. All Rights Reserved.
 */
package com.geekcap.modeler.service;

import java.io.InputStream;

/**
 * Defines the business methods exposed by the ModelerService, which is used to generate
 * artifacts from a UML model.
 *
 * @author shaines
 */
public interface ModelerService
{
    /**
     * Executes the appropriate template to convert the source reader into the destination writer.
     * 
     * @param source        An input stream that references the source UML model
     * @param destination   The destination location to which to generate the artifacts
     * @param artifact      The type of artifact to generate
     */
    public void generate( InputStream source, String destination, String artifact );
}
