/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.geekcap.modeler.service;

import com.geekcap.modeler.dao.TemplateDao;
import com.geekcap.modeler.model.DomainObject;
import com.geekcap.modeler.model.DomainModel;
import java.util.List;

/**
 * Defines the business methods exposed by the TemplateService
 *
 * @author shaines
 */
public interface TemplateService
{
    /**
     * Transforms the domain object using the specified template and returns the result
     * 
     * @param domainObject          The domain object to transform
     * @param templateName          The name of the template that should be used to perform the transformation
     * 
     * @return                      The transformed object
     */
    public String transform( DomainObject domainObject, String templateName );

    /**
     * Transforms the list of domain objects using the specified template and returns the result
     *
     * @param domainModel           The domain model to transform
     * @param templateName          The name of the template that should be used to perform the transformation
     *
     * @return                      The transformed object
     */
    public String transform( DomainModel domainModel, String templateName );

    /**
     * Injects a TemplateDao into the service
     *
     * @param templateDao           The TemplateDao through which the service should load templates
     */
    public void setTemplateDao( TemplateDao templateDao );
}
